// • ▌ ▄ ·.  ▄▄▄·  ▄▄ • ▪   ▄▄· ▄▄▄▄·  ▄▄▄·  ▐▄▄▄  ▄▄▄ .
// ·██ ▐███▪▐█ ▀█ ▐█ ▀ ▪██ ▐█ ▌▪▐█ ▀█▪▐█ ▀█ •█▌ ▐█▐▌·
// ▐█ ▌▐▌▐█·▄█▀▀█ ▄█ ▀█▄▐█·██ ▄▄▐█▀▀█▄▄█▀▀█ ▐█▐ ▐▌▐▀▀▀
// ██ ██▌▐█▌▐█ ▪▐▌▐█▄▪▐█▐█▌▐███▌██▄▪▐█▐█ ▪▐▌██▐ █▌▐█▄▄▌
// ▀▀  █▪▀▀▀ ▀  ▀ ·▀▀▀▀ ▀▀▀·▀▀▀ ·▀▀▀▀  ▀  ▀ ▀▀  █▪ ▀▀▀
//      Magicbane Emulator Project © 2013 - 2022
//                www.magicbane.com


package engine.jobs;

import engine.job.AbstractScheduleJob;
import engine.objects.PlayerCharacter;
import engine.server.world.WorldServer;

public class LogoutCharacterJob extends AbstractScheduleJob {

    private final PlayerCharacter pc;
    private final WorldServer server;

    public LogoutCharacterJob(PlayerCharacter pc, WorldServer server) {
        super();
        this.pc = pc;
        this.server = server;
    }

    @Override
    protected void doJob() {
        server.logoutCharacter(this.pc);
    }

    @Override
    protected void _cancelJob() {
        // TODO Auto-generated method stub

    }
}
