package engine.mobileAI.BehaviourFiles;

import engine.Enum;
import engine.mobileAI.utilities.CombatUtilities;
import engine.objects.Mob;

public class SiegeMob {
    public static void process(Mob treb){
        if(!treb.isAlive()){
            if(!treb.despawned){
                treb.despawn();
                treb.deathTime = System.currentTimeMillis();
                return;
            }

            if(treb.deathTime == 0) {
                treb.deathTime = System.currentTimeMillis();
                return;
            }
            if(treb.deathTime + 900000L > System.currentTimeMillis()) {
                treb.respawn();
                treb.setCombatTarget(null);
                return;
            }
        }
        if(treb.combatTarget == null)
            return;

        if(!treb.combatTarget.getObjectType().equals(Enum.GameObjectType.Building)) {
            treb.setCombatTarget(null);
            return;
        }

        if(!treb.combatTarget.isAlive()) {
            treb.setCombatTarget(null);
            return;
        }

        if(!CombatUtilities.inRangeToAttack(treb,treb.combatTarget))
            treb.setCombatTarget(null);

        if (System.currentTimeMillis() > treb.getNextAttackTime()) {
            CombatUtilities.combatCycle(treb, treb.combatTarget, true, null);
            treb.setNextAttackTime(System.currentTimeMillis() + 11000L);
        }
    }
}
